// ChangeListener
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.layout.*;
import javafx.geometry.*;
import javafx.scene.shape.*;
import javafx.scene.paint.*;

public class HSBColorMaker extends Application {
Slider hueS;  //FpXC_
Slider saturationS;  //ʓxpXC_
Slider brightS;   //xpXC_
Rectangle rect;
	@Override
	public void start(Stage pstage) {
		hueS = new Slider(0, 360, 0);
		saturationS = new Slider(0, 100, 0);
		brightS = new Slider(0, 100, 0);
		TextField hueTf = new TextField("0");
		TextField saturationTf = new TextField("0");
		TextField brightTf = new TextField("0");
		setSliderAndTextField(hueS, hueTf, 90);
		setSliderAndTextField(saturationS, saturationTf, 20);
		setSliderAndTextField(brightS, brightTf, 20);

		//Ŝ̔zu
		GridPane grid = new GridPane();
		grid.setHgap(20);
		grid.addRow(0, new Label("F()"), hueS, hueTf);
		grid.addRow(1, new Label("ʓx(%)"), saturationS, saturationTf);
		grid.addRow(2, new Label("x(%)"), brightS, brightTf);
	
		rect = new Rectangle(100, 100);
		HBox root = new HBox(20);
		root.getChildren().addAll(rect, grid);
		root.setAlignment(Pos.CENTER);
		root.setPadding(new Insets(20, 20, 20, 20));
		Scene scene = new Scene(root);
		pstage.setTitle("HSB Color Maker");
		pstage.setScene(scene);
		pstage.show();
	}
	//XC_ƃeLXgtB[h̐ݒ胁\bh (XC_CeLXgtB[hCXC_̃Ԋu)
	void setSliderAndTextField(Slider slider, TextField tf, double tickUnit){
		slider.setPrefWidth(300);
		slider.setShowTickLabels(true);
		slider.setShowTickMarks(true);
		slider.setMajorTickUnit(tickUnit);
		//tf.setPrefWidth(70);
		tf.setPrefColumnCount(5);
		slider.valueProperty().addListener((ov, oldValue, newValue) -> {
			tf.setText(String.format("%.2f", newValue.doubleValue()));
			mixColor();
		});
		tf.setOnAction((event) -> {
			double v;
			try{ //f[^擾
				v = Double.parseDouble(tf.getText()); //double^ɕϊ
			} catch (NumberFormatException error){ v = 0.0; } 
			if(v > 0){
				slider.setValue(v);
				mixColor();
			}
		});
	}
    
	void mixColor(){
		rect.setFill(Color.hsb(hueS.getValue(), saturationS.getValue()/100, brightS.getValue()/100));
	}
	public static void main(String[] args) {
		launch(args);
    }
}
